// BODY̒`

#ifndef _BODY_H_
#define _BODY_H_

#include "StdAfx.h"

#define ALL_ENTITY_TYPE_NUM	20		// SGeBeB^Cv̐
#define CTLPNUMMAX  256		// NURBSŗpRg[|Cg̐̏
#define KNOTNUMMAX  256		// NURBSŗpmbgV[PX̐̏
#define GEOMTRYELEM 0		// IGESfBNg"Entity Use Flag"A􉽗vf
#define PARAMETRICELEM 5	// IGESfBNg"Entity Use Flag"A2DpgbNvf

typedef WSClistData BODYList;	// WideStudiopӂf[^Xǧ^BODYListƂčēo^
typedef WSClistData OBJECTList;	// WideStudiopӂf[^Xǧ^OBJECTListƂčēo^

// GeBeB^CṽV{`
#define	CIRCLE_ARC					100		// ~/~
#define	COMPOSITE_CURVE				102		// Ȑ
#define	CONIC_ARC					104		// ~Ȑ
#define	COPIOUS_DATA				106		// Lӓ_
#define	PLANE						108		// 
#define	LINE						110		// 
#define	PARAMETRIC_SPLINE_CURVE		112		// pgbNXvCȐ
#define	PARAMETRIC_SPLINE_SURFACE	114		// pgbNXvCȖ
#define	POINT						116		// _
#define	TRANSFORMATION_MATRIX		124		// ϊs
#define	NURBS_CURVE					126		// LBXvCȐ
#define	NURBS_SURFACE				128		// LBXvCȖ
#define	CURVE_ON_PARAMETRIC_SURFACE 142		// ʏ
#define	TRIMMED_SURFACE				144		// g
#define	SUBFIGURE_DEFINITION		308		// q}̒`
#define	ASSOCIATIVITY_INSTANCE		402		// O[v
#define	DRAWING						404		// }
#define	PROPERTY					406		// }ʃTCY
#define	SINGULAR_SUBFIGURE_INSTANCE 408		// q}̎Q
#define	VIEW						410		// ۖ

// GeBeB^CṽV{enumŒ`
enum EntityType{
	_CIRCLE_ARC,					// ~E~
	_COMPOSITE_CURVE,				// Ȑ
	_CONIC_ARC,						// ~Ȑ
	_COPIOUS_DATA,					// Lӓ_
	_PLANE,							// 
	_LINE,							// 
	_PARAMETRIC_SPLINE_CURVE,		// pgbNXvCȐ
	_PARAMETRIC_SPLINE_SURFACE,		// pgbNXvCȖ
	_POINT,							// _
	_TRANSFORMATION_MATRIX,			// ϊs
	_NURBSC,						// LBXvCȐ
	_NURBSS,						// LBXvCȖ
	_CURVE_ON_PARAMETRIC_SURFACE,	// ʏ
	_TRIMMED_SURFACE,				// g
	_SUBFIGURE_DEFINITION,			// q}̒`
	_ASSOCIATIVITY_INSTANCE,		// O[v
	_DRAWING,						// }
	_PROPERTY,						// }ʃTCY
	_SINGULAR_SUBFIGURE_INSTANCE,	// q}̎Q
	_VIEW							// ۖ
};

/*
 * GeBeB^CvƂɍ\̂`
 * 9̃GeBeB^CvǂݍݑΏۂƂ(ȊO͓ǂݎ̂)
 * ǉꍇ́AȉɒǉGeBeB^Cv̍\̂`Ă
 */

// ~E~
typedef struct{
	double zt;		// Z̐[
	Coord  cp[3];	// ~E~ʂ̒S_An_AI_
	double R;		// a
	double t[2];	// t[0]:n_̊px t[1]:I_̊px
	int EntUseFlag; // fBNg Entity Use Flag ̒l(0:􉽗vf 5:2DpgbNvf)
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}CIRA;

// ~Ȑ
typedef struct{
	double prop[6];	// W
	double zt;		// ZTʂ̒`
	Coord  cp[2];	// n_AI_
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}CONA;

// 
typedef struct{
	Coord cp[2];	// n_AI_
	int EntUseFlag; // fBNg Entity Use Flag ̒l(0:􉽗vf 5:2DpgbNvf)
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}LINE_;

// ϊ}gbNX
typedef struct{
	double R[3][3];	// ]s
	double T[3];	// ixNg
	int pD;			// fBNgւ̋t|C^
}TMAT;

// LBXvC(NURBS)Ȑ
typedef struct{
	int K;			// Rg[|Cg̐
	int M;			// K(=+1)
	int N;			// mbgxNg̐
	int prop[4];	// evpeB
	double *T;		// mbgV[PX̒l A+1
	double *W;		// Weight̒l K+1
	Coord *cp;		// Rg[|Cg K+1
	double V[2];	// p[^͈̔
	Coord norm;		// @xNg
	int EntUseFlag; // fBNg Entity Use Flag ̒l(0:􉽗vf 5:2DpgbNvf)
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}NURBSC;

// LBXvC(NURBS)Ȗ
typedef struct{
	int K[2];		// Rg[|Cg̐(u,v)
	int M[2];		// K(=+1)
	int N[2];		// mbgxNg̐
	int prop[5];	// p[^
	double *S;		// umbgxNg̒l A+1
	double *T;		// vmbgxNg̒l B+1
	double **W;		// Weight̒l
	Coord  **cp;	// Rg[|Cg C
	double U[2];	// up[^
	double V[2];	// vp[^
	int pD;			// fBNgւ̋t|C^
	int TrmdSurfFlag;// NURBSȖʂgʂƂČĂ΂Ă̂AƗđ݂̂tO(g:KOD_TRUE  Ɨ:KOD_FALSE)
	DispStat Dstat;	// \iFr,g,b,j
}NURBSS;

// Ȑ\łȐQp̂Ő錾
typedef union{
	CIRA CirA;		// ~E~
	CONA ConA;		// ~Ȑ
	LINE_ Line;		// 
	NURBSC NurbsC;	// NURBSȐ
}COMPELEM;

// Ȑ
typedef struct{
	int N;			// \vf
	int *DEType;	// e\vf̃GeBeB^Cv
	COMPELEM **pDE;	// e\vf̍\̂ւ̃|C^
	int DegeFlag;	// Ȑkނ2DpgbNȐ\tO
	NURBSC DegeNurbs;// Ȑkނ2DpgbNȐꍇɏkނ邽߂NURBSȐ
	int pD;			// fBNgւ̋t|C^
}COMPC;

// ʏ\łȐQp̂Ő錾
typedef union{
	CIRA  CirA;		// ~E~
	COMPC CompC;	// Ȑ
	CONA  ConA;		// ~Ȑ
	NURBSC NurbsC;	// NURBSȐ
}CURVE;

// ʏ
typedef struct{
	int crtn;		// ʏǂ̂悤ɍꂽ
	int SType;		// Surface S̃GeBeB^Cv
	int BType;		// Curve B̃GeBeB^Cv
	int CType;		// Curve C̃GeBeB^Cv
	NURBSS *pS;		// CurveSurface\̂ւ̃|C^
	CURVE *pB;		// Surface S̃p[^ԂɂCurve B\̂ւ̃|C^
	CURVE *pC;		// Curve C\̂ւ̃|C^
	int pref;		// 葤VXeō̂Ă\tO
	int pD;			// fBNgւ̋t|C^
}CONPS;

// g
typedef struct{
	NURBSS *pts;	// gSurface EntityDEւ̃|C^
	int n1;			// 0:OD̋EƈvA1:ȊO
	int n2;			// Trimmed Surface̓ɂPȐ̐
	CONPS *pTO;		// Trimmed Surface̊OɂPȐ\̂ւ̃|C^
	CONPS **pTI;	// Trimmed Surface̓ɂPȐ\̂ւ̃|C^
	int pD;			// fBNgւ̋t|C^
}TRMS;

typedef TRMS TRIMD_NURBSS;	// gʂɑ΂NurbsȖʂzN閼̂^Ă

// pXΏۃGeBeB\
typedef struct{
	int Body;		// BODYIuWFNg̔ԍ
	int Type;		// GeBeB^CṽV{(NURBSȐ:126 , NURBSȖ:128 , g:144)
	int Num;		// Typeɂvfԍ(NURBSȐ4{A4{Ɋ蓖Ăꂽ0`3̔ԍ)
	int CCount;		// ԖڂɃsbNꂽȐ\
	int SCount;		// ԖڂɃsbNꂽȖʂ\
}OBJECT;

// SẴGeBeB𓝊BODY\
typedef struct{
	CIRA  *CirA;		// ~E~
	COMPC *CompC;		// Ȑ
	CONA  *ConA;		// ~Ȑ
	LINE_ *Line;		// 
	TMAT  *TMat;		// ϊs
	NURBSC *NurbsC;		// NRBSȐ
	NURBSS *NurbsS;		// NRBSȖ
	CONPS *ConpS;		// ʏ
	TRMS  *TrmS;		// g
	double MaxCoord;	// ̂̐@̍ől(̒lŏ\{)
	int  TypeNum[ALL_ENTITY_TYPE_NUM];	// BODY\eGeBeB̐i[z
	char Name[FNAMEMAX];	// BODY
}BODY;

class BODY_Handler
{
public:
	void InitCurveColor(float *);							// ̐F̏l^
	void InitSurfaceColor(float *);							// ʂ̐F̏l^
	void ChangeStatColor(float *,float,float,float,float);	// GeBeB̃Xe[^XŒ`ĂFύX
	BODY *SearchBodyList(BODYList *,int);					// ZNVĂBODYԍ𓾂
	void Init_body(BODY *);									// BODY
	void RegistNurbsCtoBody(BODYList *,BODY *,NURBSC,char []);	// 1NURBCȐVBODYƂēo^
	void RegistNurbsCtoBodyN(BODYList *,BODY *,NURBSC [],char [],int);	// NNURBCȐVBODYƂēo^
	void RegistNurbsStoBody(BODYList *,BODY *,NURBSS,char []);	// 1NURBSȖʂVBODYƂēo^
	void RegistNurbsStoBodyN(BODYList *,BODY *,NURBSS [],char [],int);	// NNURBSȖʂVBODYƂēo^


	// eGeBeB̃[֐
	void New_body(BODY *,int []);				// SGeBeB̃[m
	void Free_body(BODY *,int []);				// SGeBeB̃[
	int New_CompC(COMPC *,int);					// Ȑ̃[m
	void Free_CompC_1DArray(COMPC *,int);		// Ȑz̃[
	void Free_CompC(COMPC *);					// Ȑ̃[
	int New_NurbsC(NURBSC *,int,int);			// NURBSȐ̃[m
	void Free_NurbsC_1DArray(NURBSC *,int);		// NURBSȐz̃[
	void Free_NurbsC(NURBSC *);					// NURBSȐ̃[
	int New_NurbsS(NURBSS *,int [],int []);		// NURBSȖʂ̃[m
	void Free_NurbsS_1DArray(NURBSS *,int);		// NURBSȖʔz̃[
	void Free_NurbsS(NURBSS *);					// NURBSȖʂ̃[
	int New_TrmS(TRMS *,int);					// gʂ̃[m
	void Free_TrmS_1DArray(TRMS *,int);			// gʔz̃[
	void Free_TrmS(TRMS *);						// gʂ̃[

};

#endif
