// NurbsȐ_CAÕvV[W
#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
#include "Kodatuno.h"

void NurbsCDlg_Proc(WSCbase* object)
{
	if(NurbsCurve_Dlg == NULL)	return;

	if(NurbsCurve_Dlg->getStatus() == WS_DIALOG_OK){		// OK{^ꂽ

		WSCstring fname = InpFileName->getProperty(WSNlabelString);		// Cvbgt@C擾
		if(!fname.getChars()){
			SetMessage("You do not choose a file.");
			return;
		}

		int val = NurbsCOpt->getProperty(WSNvalue);			// WI{^̑Iԍ𓾂
		switch(val){
			case 1:
				SetMessage("You chose generating Polygonal Nurbs Curve.");
				break;
			case 2:
				SetMessage("You chose generating Interpolated Nurbs Curve (1).");
				break;
			case 3:
				SetMessage(" You chose generating Approximated Nurbs Curve.");
				break;
			case 4:
				SetMessage("You chose generating Interpolated Nurbs Curve (2).");
				break;
			case 5:
				SetMessage("No supported");
				break;
		}

		WSCstring mes("Input file name is ");
		mes.addString(fname);
		SetMessage(mes);

		int rank = NurbsC_Rank->getProperty(WSNlabelString);	// NURBSȐ̊K擾
		if(rank > RANKMAX || rank <= 0){
			char mes[256];
			sprintf(mes,"KODATUNO ERROR: Inappropriate Rank ( 0 <= Rank <= %d)");
			SetMessage(mes);
			return;
		}

		Kodatuno.GenNurbsCurve(val,fname,rank);		// NURBSȐ

		NurbsCurve_Dlg->setVisible(False);			// _CAO

		Describe_Form->redraw();		// `̈ɍĕ`w
	}
}
static WSCfunctionRegister  op("NurbsCDlg_Proc",(void*)NurbsCDlg_Proc);
