#ifndef _STD_AFX_H_
#define _STD_AFX_H_

// R[obNɊւWindowsUNIX̌݊ۂ}N(Ԃ)
#ifdef _MSC_VER
#ifndef CALLBACK
#define CALLBACK __stdcall
#endif
#define EXPORT extern "C" __declspec(dllexport)
#else
#ifndef CALLBACK
#define	CALLBACK
#endif
#define EXPORT extern "C"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <GL/gl.h>
#ifndef MacOS
#include <GL/glut.h>
#else
#include <GLUT/glut.h>
#endif

#include <WSCfileSelect.h>
#include <WSCmessageDialog.h>
#include <WSCimageSet.h>
#include <WSDkeyboard.h>
#include <WSDmwindowDev.h>
#include <WSDmouse.h>
#include <WSCcolorSet.h>
#include "Kodatuno_Win.h"


#define KOD_ERR	-1					// ERROR̃V{
#define KOD_FALSE	0				// ŨV{
#define KOD_TRUE	1				// ^̃V{
#define KOD_DONE	2				// sς݂V{
#define KOD_ONEDGE	2				// _GbWɂ邱ƂV{
#define KOD_EQUAL	2				// l̃V{
#define LOW_ACCURACY  0				// ᐸx̃V{
#define MID_ACCURACY  1				// ʐx̃V{
#define HIGH_ACCURACY 2				// x̃V{
#define FNAMEMAX	256				// t@C̍ő啶
#define PI 3.141592653589793		// ~
#define APPROX_ZERO_L 1.0e-3		// [ƌȂl(ᐸx)
#define APPROX_ZERO	1.0e-6			// [ƌȂl(ʐx)
#define APPROX_ZERO_H 1.0e-12		// [ƌȂl(x)
#define LOOPCOUNTMAX		1000	// vZ񐔂̏


typedef double **Matrix;	// double`2zMatrixƂĒ`
typedef double *Vector;		// double`1zVectorƂĒ`

// Wp\̂`
typedef struct{
	double x,y,z;	// x,y,zWl
	double dmy;		// ėp
}Coord;

// ϊsp\
typedef struct{
	Coord Rot[3];	// ]s
	Coord Trl;		// i
}FRAME;

// \p\
typedef struct{
	float Color[4];	// F(r,g,b,?)
	// \̒ǉ͂ɋLq
}DispStat;

// O[oȊ֐̒` ///////////////////////////////////////////////////////////////////////////

// ,3xNgZ
void InitCoord(Coord *);						// Wl̏
void InitCoord(Coord *,int);
Coord AddCoord(Coord,Coord);					// Wl̑Z
Coord AddCoord(Coord,double);					// I[o[[h
Coord AddCoord(Coord,double,double,double);		// I[o[[h
Coord DivCoord(Coord,Coord);					// Wl̊Z
Coord DivCoord(Coord,double);					// I[o[[h
Coord DivCoord(Coord,double,double,double);		// I[o[[h
Coord MulCoord(Coord,Coord);					// Wl̊|Z(xNg̓,Oςł͂Ȃ̂Œ)
Coord MulCoord(Coord,double);					// I[o[[h
Coord MulCoord(Coord,double,double,double);		// I[o[[h
Coord SubCoord(Coord,Coord);					// Wl̈Z
Coord SubCoord(Coord,double);					// I[o[[h
Coord SubCoord(Coord,double,double,double);		// I[o[[h
Coord SetCoord(Coord);							// Wl
Coord SetCoord(double,double,double);			// I[o[[h
int DiffCoord(Coord,Coord);						// WlȂKOD_TRUEAقȂĂȂKOD_FALSEԂ
Coord AbsCoord(Coord);							// Wl̐ΒlԂ
Coord NormalizeVec(Coord);						// 3xNg𐳋K(PʃxNg)
Coord NormalizeVec(double,double,double);		// I[o[[h
double CalcEuclid(Coord);						// [NbhƂ߂
double CalcEuclid2D(double,double);				// 2[NbhƂ߂
double CalcDistance(Coord,Coord);				// 2_Ԃ̃[Nbh߂
double CalcDistance2D(Coord,Coord);				// 2Wł2_Ԃ̃[NbhZo
double CalcEuclidPnts2D(Coord,Coord);			// 2Wł2_Ԃ̃[NbhZo
double CalcInnerProduct(Coord,Coord);			// ς߂
double CalcinnerProduct(Coord,double,double,double);	// I[o[[h
Coord CalcOuterProduct(Coord,Coord);			// Oς߂
double CalcVecAngle(Coord,Coord);				// 2̃xNĝȂp߂
double CalcVecAngle2D(Coord,Coord);				// 2̃xNĝȂp߂(2D)
Coord CalcInterDivPt(Coord,Coord,double);		// 2_Ԃ̓_߂
Coord CalcOrthoProjection(Coord,Coord,Coord);	// Cӂ̓_Cӂ̕ʂ֐ˉe
double CalcDistPtToPlane(Coord,Coord,Coord);	// Cӂ̓_Cӂ̕ʂ܂ł̋߂
double CalcScalarTriProduct(Coord,Coord,Coord);	// XJ[Odς߂
Coord CalcRotVec2D(Coord,double);				// Cӂ̃xNg]xNg߂(2D)
Coord CalcRotVec(Coord,Coord,double);			// Cӂ̃xNg_ʂCӎɉ]xNg߂(3D)
Coord CalcNormalLine(Coord,Coord,Coord);		// Cӂ̓_Cӂ̒։낵_߂
Coord Arc_CP(Coord,Coord,double);				// ~̒S_(vec[0])~ɐڂCӂ2{̐ڐ_ւ̃xNg(Sp0<<)
int IsPointInPolygon(Coord,Coord *,int);		// ړ_̑p`O

// ϊsA]s̉Z
Coord MulFrameCoord(double[][3],double[],Coord);	// ϊsƍWl(3DxNg)Ƃ̊|Z
Coord MulFrameCoord(FRAME,Coord);				// I[o[[h 
FRAME MulFrame(FRAME ,FRAME);					// ϊs̊|Z
FRAME InvFrame(FRAME);							// ϊs̋ts𓾂
Coord RotToZYZEuler(Coord []);					// ]sZYZIC[p֕ϊ
void InitFrame(FRAME *);						// FRAMȄ

// xNgAs̉Z
void InitVector(Vector,int);					// 1z̏(:xNg,z)
void InitMatrix(Matrix,int,int);				// 2z̏
void MulMxMx(Matrix,int,int,Matrix,int,int,Matrix);	// s񓯎m̊|Z
void MulMxVec(Matrix,int,int,Vector,int,Vector);	// sƃxNg̊|Z
void MulMxVec(Matrix,int,int,Coord *,Coord *);	// sƍWlxNg̊|Z
Coord MulMxCoord(Coord [],Coord);				// Coordŕ\3x3sCoordxNgƂ̊|Z
Coord MulMxCoord(Matrix,Coord);					// 3x3sCoordxNgƂ̊|Z
void TranMx(Matrix,int,int,Matrix);				// ]us𓾂
void TranMx(Coord **,int,int,Coord **);			// ]us𓾂(I[o[[h)
void TranMx(Coord [],Coord []);					// ]us𓾂(I[o[[h)
double Gauss(int,Matrix,Vector,Vector);			// A1̉߂
double Gauss(int,Matrix,Coord *,Coord *);		// A1̉߂(I[o[[h)
void LU_Solver(int,Matrix,Vector,int *,Vector);	// LǓʂA1
void LU_Solver(int,Matrix,Coord *,int *,Coord *);// LǓʂA1(I[o[[h)
double LU(int,Matrix,int *);					// LU
double MatInv(int,Matrix,Matrix);				// ts߂
double MatInv3(Matrix,Matrix);					// 3x3̋ts
double MatInv2(Matrix,Matrix);					// 2x2̋ts

// lvZ
double DegToRad(double degree);					// pxPʂdegreeradian
double RadToDeg(double radian);					// pxPʂradiandegree
int CalcCubicEquation(double *,double *);		// 3̉߂
int CalcQuadraticEquation(double *,double *);	// 2̉߂
int CalcLinearEquation(double *,double *);		// 1̉߂
int nCr(int n,int r);							// 2W(nCȓg)߂
int Factorial(int n);							// Rn̊K߂

// `֘A
void DrawPoint(Coord,double,double,double []);			// _`
void DrawPoints(Coord *,int,double,double,double []);	// _Q`
void DrawVector(Coord,Coord,double,double,double []);	// xNg`
void DrawLine(Coord,Coord,double,double []);			// 2_Ԃɐ`

// [֘A
Matrix NewMatrix(int,int);			// 2double^z̃[m
Vector NewVector(int);				// 1double^z̃[m
void FreeMatrix(Matrix,int);		// 2double^z̃[
void FreeVector(Vector);			// 1double^z̃[
Coord *NewCoord1(int);				// 1Coord^z̃[m
void FreeCoord1(Coord *);			// 1Coord^z̃[
Coord **NewCoord2(int,int);			// 2Coord^z̃[m
void FreeCoord2(Coord **,int);		// 2Coord^z̃[



// R\[
void SetMessage(char *);			// R\[ɃbZ[Wo
void SetCommand(char *);			// R\[ɃR}ho

// ̑
double sgn(double);						// 
int CheckZero(double,int);				// lAPPROX_ZERO͈̔͂0ł邩`FbN
int CheckRange(double,double,double,int);	// w肵lw肵͈͓ł邩`FbN
int CheckMag(double,double,int);		// 2̒l̑召r 
void BubbleSort(int[],int);				// ou\[g({@)
void BubbleSort(double[],int);			// I[o[[h
int QCmp(const void *,const void *);	// NCbN\[g 

#endif
