// UserSampleLq
#include "UserFuncSub.h"

// Example 1 : NURBSȖʂƁAw肵ʂ̌߂(ʂ𒀎ItZbgĂAZo)
//   
// *Body:BODYXg̐擪AhX  
// *Obj:ZNVꂽGeBeB̏  
// pickcount:ZNVꂽGeBeB
int ExecSampleFunc1(BODYList *BodyList,OBJECTList *ObjList,int pickcount,double prop[])
{
	if(!pickcount)	return KOD_ERR;		// ZNVĂȂAȂ

	BODY *body;
	OBJECT *obj;
	int i;

	// ZNVꂽ[v
	for(i=0;i<pickcount;i++){
		obj = (OBJECT *)ObjList->getData(i);				// ZNVꂽGeBeB̏𓾂
		body = (BODY *)BodyList->getData(obj->Body);		// ZNVꂽBODY̎̂𓾂

		// ZNVꂽGeBeBgʂNURBSȖ
		if(obj->Type == _TRIMMED_SURFACE || obj->Type == _NURBSS){
				ContourLine(&body->NurbsS[obj->Num],prop[0],prop[1],prop[2],prop[3]);
		}

		// ZNVꂽGeBeBNURBSȐ
		else if(obj->Type == _NURBSC){						
			// ǉĂ
		}
	}

	return KOD_TRUE;
}


// TvƂĕʂNURBSȐ̌(_Q)ZovO
// ʂZɃVtgĂAeZʒuł̌𒀎߂
//   *NurbsSFZoΏۂƂȂNurbsȖʂւ̃|C^
//       upper_zFNurbsȖʂƌx-yʂz̍ől
//       under_zFNurbsȖʂƌx-yʂz̍ŏl
//       deltaFNurbsȖʂƌx-yʂzsbNtB[h
//       roughnessF̍r(0.1`1)
int ContourLine(NURBSS *NurbsS,double upper_z,double under_z,double delta,double roughness)
{
	NURBS_Func NFunc;				// NURBS֘Å֐W߂NX̃IuWFNg𐶐
	Coord t[5000];					// 
	int   num;						// ̐
	Coord pt=SetCoord(0,0,10);		// ʏ1_w
	Coord nvec=SetCoord(0,0,1);		// ʂ̖@xNgw
	double pcolor[3] = {0,1,0};		// \̐F
	double tcolor[3] = {1,0,0};

	int step = fabs(upper_z - under_z)/delta + 1;

	for(int i=0;i<step;i++){
		double z = under_z + delta*(double)i;
		if(z == 0.0) continue;			// z=0͓̎ٓ_Ȃ̂ŌvZȂ
		pt = SetCoord(0,0,z);			// ʂZɏXɃVtgĂ
		char mes[256];
		sprintf(mes,"z=%.3lf  calculating...",z);
		SetMessage(mes);
		num = NFunc.CalcIntersecPtsPlaneSearch3(NurbsS,pt,nvec,roughness,10,t,5000);		// NURBSȖʂƕʂƂ̌_QǐՖ@ŋ߂
		sprintf(mes,"num = %d",num);
		SetMessage(mes);

		for(int i=0;i<num;i++){		// _̐[v
			//if(i%5 == 0){
				Coord p = NFunc.CalcNurbsSCoord(NurbsS,t[i].x,t[i].y);			// _p[^lWl֕ϊ
				Coord nt = NFunc.CalcNormVecOnNurbsS(NurbsS,t[i].x,t[i].y);		// _̖@xNgvZ
				nt = MulCoord(nt,-1);											// O@xNg֕ϊ
				DrawPoint(p,1,3,pcolor);			// _`
				DrawVector(p,nt,3,1,tcolor);		// @xNg`
			//}
		}
	}
	SetMessage("END");

	return KOD_TRUE;
}


// Example 2 : NURBSȖʓm̌Zo
//   
// *Body:BODYXg̐擪AhX  
// *Obj:ZNVꂽGeBeB̏  
// pickcount:ZNVꂽGeBeB
// prop: prop[0]:_T[`̕   prop[1]:ǐՕ
int ExecSampleFunc2(BODYList *BodyList,OBJECTList *ObjList,int pickcount,double prop[])
{
	if(!pickcount)	return KOD_ERR;

	BODY *body;
	OBJECT *obj;
	TRIMD_NURBSS *tnurbs[100];	// NURBSȖʂւ̃|C^i[
	int surf_body[100];
	int surf_type[100];			// Ȗʂ̃^Cvi[
	int surf_objn[100];
	int scount=0;				// ȖʐJE^
	NURBS_Func NFunc;			// NURBS֘Å֐W߂NX̃IuWFNg𐶐
	Coord Rt[5000];				// NURBSȖR(w,t)ɂ
	Coord St[5000];				// NURBSȖS(u,v)ɂ
	double green[3] = {0,1,0};	// \̐F
	int flag_r;					// gʃtO
	int flag_s;					// 

	SetMessage("Start calcu....");

	// ZNVꂽ[v
	// eȖʂ"g"Ȃ̂"gȂNURBSȖ"Ȃׂ̂
	for(int i=0;i<pickcount;i++){
		obj = (OBJECT *)ObjList->getData(i);
		body = (BODY *)BodyList->getData(obj->Body);		// ZNVꂽBODYf[^𓾂

		if(obj->Type != _TRIMMED_SURFACE && obj->Type != _NURBSS)	// ZNVꂽGeBeBgʂłNURBSȖʂłȂꍇ
			continue;

		else if(obj->Type == _TRIMMED_SURFACE)				// ZNVꂽGeBeBg
			tnurbs[scount] = &body->TrmS[obj->Num];			// ZNVꂽNURBSȖʂꎞo^

		else if(obj->Type == _NURBSS)						// ZNVꂽGeBeBNURBSȖ
			tnurbs[scount]->pts = &body->NurbsS[obj->Num];	// ZNVꂽNURBSȖʂꎞo^
		surf_body[scount] = obj->Body;
		surf_type[scount] = obj->Type;						// ڒ̖ʂ̃^CvL
		surf_objn[scount] = obj->Num;
		scount++;											// ʂJEg
		if(scount == 100){
			SetMessage("USER FUNC ERROR: Too Many Surfaces");
			return KOD_ERR;
		}
	}

	// IꂽʑSĂ̑gݍ킹ŌZo
	for(int i=0;i<scount-1;i++){
		for(int j=i+1;j<scount;j++){
			if(surf_body[i] == surf_body[j])	continue;
			fprintf(stderr,"%d-(%d,%d)\n",scount,i,j);
			int num = NFunc.CalcIntersecPtsNurbsSSearch(tnurbs[i]->pts,tnurbs[j]->pts,(int)prop[0],prop[1],Rt,St,5000);	// NURBSȖʓm̌Zo
			// `
			for(int k=0;k<num;k++){
				flag_r = flag_s = KOD_TRUE;
				if(surf_type[i] == _TRIMMED_SURFACE)								// NurbsRg
					flag_r = NFunc.DetermPtOnTRMSurf(tnurbs[i],Rt[k].x,Rt[k].y);	// ڒ̌_̃gʓO
				if(surf_type[j] == _TRIMMED_SURFACE)								// NurbsSg
					flag_s = NFunc.DetermPtOnTRMSurf(tnurbs[j],St[k].x,St[k].y);	// ڒ̌_̃gʓO
				if(flag_r == KOD_TRUE && flag_s == KOD_TRUE){						// NurbsR,NurbsSƂflag==TRUÊƂ̂݁A_Ƃĕ\
					Coord p = NFunc.CalcNurbsSCoord(tnurbs[i]->pts,Rt[k].x,Rt[k].y);// uvW̓_xyzWlɕϊ
					DrawPoint(p,1,6,green);											// `
				}
			}
			fprintf(stderr,"done\n");
		}
	}

	SetMessage("END");

	return KOD_TRUE;
}
