/***************
* BODY`RA *
****************/

#include "Describe_BODY.h"

// RXgN^
Describe_BODY::Describe_BODY()
{
	SetNurbsStat();
}

// fXgN^
Describe_BODY::~Describe_BODY()
{
}

// ̕`
void Describe_BODY::DrawLine(LINE_ Line)
{
	glLineWidth(1);

	glBegin(GL_LINE_STRIP);
	glVertex3d(Line.cp[0].x,Line.cp[0].y,Line.cp[0].z);	// n_
	glVertex3d(Line.cp[1].x,Line.cp[1].y,Line.cp[1].z);	// I_
	glEnd();

}

// NURBSȐ̕`
void Describe_BODY::DrawNurbsCurve(NURBSC NurbsC)
{
	int i,j;

	for(i=0;i<NurbsC.K;i++){			// Rg[|Cgo
		CCtlp[i][0] = NurbsC.cp[i].x*NurbsC.W[i];
		CCtlp[i][1] = NurbsC.cp[i].y*NurbsC.W[i];
		CCtlp[i][2] = NurbsC.cp[i].z*NurbsC.W[i];
		CCtlp[i][3] = NurbsC.W[i];
	}

	for(j=0;j<NurbsC.N;j++){			// mbgxNgo
		uKnot[j] = NurbsC.T[j];
	}

	glDisable(GL_LIGHTING);
	gluBeginCurve(NurbsCurve);

	gluNurbsCurve(NurbsCurve,NurbsC.N,uKnot,4,&CCtlp[0][0],NurbsC.M,GL_MAP1_VERTEX_4);	// mbgxNg̒l͈̔͂0`1łȂƁA
	gluEndCurve(NurbsCurve);															// "mbgXvC߂葽܂Ɠ{"
	glFlush();																			// mbgxNg̐KKv(pp111)
	glEnable(GL_LIGHTING);

}


// NURBSȖʂ̕`(g)
void Describe_BODY::DrawTrimdNurbsSurfe(NURBSS *NurbsS)
{
	int j,k;

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,NurbsS->Dstat.Color);
	for(k=0;k<NurbsS->K[1];k++){
		for(j=0;j<NurbsS->K[0];j++){
			SCtlp[j][k][0] = NurbsS->cp[j][k].x*NurbsS->W[j][k];	// Rg[|Cgo
			SCtlp[j][k][1] = NurbsS->cp[j][k].y*NurbsS->W[j][k];
			SCtlp[j][k][2] = NurbsS->cp[j][k].z*NurbsS->W[j][k];
			SCtlp[j][k][3] = NurbsS->W[j][k];
		}
	}
	for(j=0;j<NurbsS->N[0];j++){
		uKnot[j] = NurbsS->S[j];		// umbgxNgo
		//fprintf(stderr,"U:%d-%.12lf\n",j+1,uKnot[j]);
	}
	for(j=0;j<NurbsS->N[1];j++){
		vKnot[j] = NurbsS->T[j];		// vmbgxNgo
		//fprintf(stderr,"V:%d-%.12lf\n",j+1,vKnot[j]);
	}

	// NURBSȖʂ̕`
	gluNurbsSurface(NurbsSurf,(GLdouble)NurbsS->N[0],uKnot,(GLdouble)NurbsS->N[1],vKnot,CTLPNUMMAX*4,4,&SCtlp[0][0][0],NurbsS->M[0],NurbsS->M[1],GL_MAP2_VERTEX_4);
}

// NURBSȖʂ̕`(gȂ)
void Describe_BODY::DrawNurbsSurfe(NURBSS NurbsS)
{
	int j,k;

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,NurbsS.Dstat.Color);
	for(k=0;k<NurbsS.K[1];k++){
		for(j=0;j<NurbsS.K[0];j++){
			SCtlp[j][k][0] = NurbsS.cp[j][k].x*NurbsS.W[j][k];	// Rg[|Cgo
			SCtlp[j][k][1] = NurbsS.cp[j][k].y*NurbsS.W[j][k];
			SCtlp[j][k][2] = NurbsS.cp[j][k].z*NurbsS.W[j][k];
			SCtlp[j][k][3] = NurbsS.W[j][k];
		}
	}
	for(j=0;j<NurbsS.N[0];j++){
		uKnot[j] = NurbsS.S[j];		// umbgxNgo
	}
	for(j=0;j<NurbsS.N[1];j++){
		vKnot[j] = NurbsS.T[j];		// vmbgxNgo
	}

	// NURBSȖʂ̕`
	gluBeginSurface(NurbsSurf);
	gluNurbsSurface(NurbsSurf,NurbsS.N[0],uKnot,NurbsS.N[1],vKnot,CTLPNUMMAX*4,4,&SCtlp[0][0][0],NurbsS.M[0],NurbsS.M[1],GL_MAP2_VERTEX_4);
	gluEndSurface(NurbsSurf);

}

// Ȑ̕`
void Describe_BODY::DrawCompositeCurve(COMPC *CompC)
{
	int i;

	for(i=0;i<CompC->N;i++){
		if(CompC->DEType[i] == NURBS_CURVE){
			DrawNurbsCurve_Param((NURBSC *)CompC->pDE[i]);	// NURBSȐ
		}
		//else if(CompC->DEType[i] == CIRCLE_ARC){
		//	glDraw_CircleArc_Param((CIRA *)CompC->pDE[i]);		// ~E~
		//}
		//else if(CompC->DEType[i] == CONIC_ARC){
		//	glDraw_ConicArc_Param((CONA *)CompC->pDE[i]);		// ~Ȑ
		//}
		//else if(CompC->DEType[i] == LINE){
		//	glDraw_Line_Param((LINE_ *)CompC->pDE[i]);			// 
		//}
	}

	if(CompC->DegeFlag == KOD_FALSE)
		DrawNurbsCurve_Param(&CompC->DegeNurbs);		// kނꍇAkޗpNurbsȐgGeBeBƂĒǉ
}

// ʏ̕`
void Describe_BODY::DrawCurveOnParamSurfe(CONPS *ConpS)
{
	// 2DpgbNȐ
	if(ConpS->BType == COMPOSITE_CURVE){
		DrawCompositeCurve((COMPC *)ConpS->pB);	// Ȑ
	}
//	else if(ConpS->BType == NURBS_SURFACE){
//		glDraw_NurbsCurve(ConpS->pB);		// NURBSȐ
//	}
//	else if(ConpS->BType == CIRCLE_ARC){
//		glDraw_CircleArc(ConpS->pB);		// ~E~
//	}
//	else if(ConpS->BType == CONIC_ARC){
//		glDraw_ConicArc();					// ~Ȑ
//	}
}

// gʂ̕`
void Describe_BODY::DrawTrimdSurf(TRMS TrmS)
{
	gluBeginSurface(NurbsSurf);

	DrawTrimdNurbsSurfe(TrmS.pts);				// NURBSȖʂ̕`

	// Og
	gluBeginTrim(NurbsSurf);
	DrawCurveOnParamSurfe(TrmS.pTO);			// ʏ
	gluEndTrim(NurbsSurf);

	// g
	for(int j=0;j<TrmS.n2;j++){
		gluBeginTrim(NurbsSurf);
		DrawCurveOnParamSurfe(TrmS.pTI[j]);		// ʏ
		gluEndTrim(NurbsSurf);
	}

	gluEndSurface(NurbsSurf);

}

// 2DpgbNNURBSȐvf̕`
void Describe_BODY::DrawNurbsCurve_Param(NURBSC *NurbsC)
{
	int i;

	for(i=0;i<NurbsC->K;i++){			// Rg[|Cgo
		CCtlp[i][0] = NurbsC->cp[i].x*NurbsC->W[i];
		CCtlp[i][1] = NurbsC->cp[i].y*NurbsC->W[i];
		CCtlp[i][2] = NurbsC->W[i];
	}
	for(i=0;i<NurbsC->N;i++){			// mbgxNgo
		uKnot[i] = NurbsC->T[i];
	}

	// gʂ\NURBSȐw
	gluNurbsCurve(NurbsSurf,NurbsC->N,uKnot,4,&CCtlp[0][0],NurbsC->M,GLU_MAP1_TRIM_3);

}

// kރ`FbN
void Describe_BODY::CheckDegenracy(BODY *body)
{
	int flag;
	NURBS_Func NFunc;

	// kޗpNurbsȐ𕡍Ȑ̐
	if(body->TypeNum[_COMPOSITE_CURVE]){
		double T[4] = {0,0,1,1};
		double W[2] = {1,1};
		double V[2] = {0,1};
		int prop[4] = {0,0,1,0};
		Coord cp[2];
		InitCoord(&cp[0]);
		InitCoord(&cp[1]);

		for(int i=0;i<body->TypeNum[_COMPOSITE_CURVE];i++){
			 NFunc.GenNurbsC(&body->CompC[i].DegeNurbs,2,2,4,T,W,cp,V,prop,1);	// kޗpNurbsȐ𕡍Ȑ̃GeBeB

			// eȐNURBSȐ݂̂ō\Ă肩2DpgbNvfł邩̃`FbN
			flag = 0;
			for(int j=0;j<body->CompC[i].N;j++){
				if(body->CompC[i].DEType[j] == NURBS_CURVE && body->CompC[i].pDE[j]->NurbsC.EntUseFlag == PARAMETRICELEM){
					flag++;				
				}
			}

			// NURBSȐō\Ă镡Ȑɑ΂āAn_ƏI_̍Wlr
			if(flag == body->CompC[i].N){
				Coord s,e;
				s = NFunc.CalcNurbsCCoord(&body->CompC[i].pDE[0]->NurbsC,body->CompC[i].pDE[0]->NurbsC.V[0]);					// n_
				e = NFunc.CalcNurbsCCoord(&body->CompC[i].pDE[body->CompC[i].N-1]->NurbsC,body->CompC[i].pDE[body->CompC[i].N-1]->NurbsC.V[1]);	// I_
				if(DiffCoord(s,e) == KOD_FALSE){				// n_I_
					body->CompC[i].DegeNurbs.cp[0] = e;
					body->CompC[i].DegeNurbs.cp[1] = s;
					body->CompC[i].DegeFlag = KOD_FALSE;			// kނ̃tO𗧂Ă
				}
				else{
					body->CompC[i].DegeFlag = KOD_TRUE;				// kނȂ̃tO𗧂Ă
				}
			}
			else{
				body->CompC[i].DegeFlag = KOD_TRUE;					// ȐNurbsȐō\ĂȂꍇkނȂ̃tO
			}
		}
	}

}

// NURBS`Xe[^X̐ݒ
void Describe_BODY::SetNurbsStat()
{
	// Notes(2010/10/26 ktaka)
	// 1.OpenGL񋟂NURBS`֐0.0001ȏ̐x0ƂĂ܂悤BāAȏ̐xŕϓ
	//   mbgxNgɊւĂ͑SēlƂȂĂ܂ANURBS_Err()R[obNo͂ƎvB
	//   @ƂāAmbgxNg͈̔͂𐳋KȂǂ0.0001傫ϓɂKv邪A
	//   ̏ꍇAx[XƂȂNURBSȖʂƃgC̑֐Ă܂߁AłȂB
	//   iNURBSȖʂ̃mbgxNg𐳋KƁAɍ킹ċȖʂ̃pgbNʏ̃gCωȂ΂ȂA
	//     gĈNURBSŕ\Ă邽߁ApgbNʏŕωgCWlgC̃Rg[|CgɕϊłȂj
	//   mbg̏ǉ邱ƂŁAxȃmbgxNg폜łȂ
	// 2.gluNewNurbsRenderer()NurbsIuWFNg1mۂꍇA1̃IuWFNgɂĒ񋟂郊\[Xȏ
	// @NURBS݂ƁAoOBāÅ֐gluNewNurbsRenderer()sAe`֐gluBegin***`gluEnd***Ԃ
	//   ͂ނ悤gluNewNurbsRenderer()gluDeleteNurbsRenderer()LqANURBS`̓xNurbsIuWFNg̊m-悢ƎvB

	NurbsCurve = gluNewNurbsRenderer();
	gluNurbsProperty(NurbsCurve,GLU_SAMPLING_TOLERANCE,50);	
	gluNurbsCallback(NurbsCurve, GLU_ERROR, (void (CALLBACK *) (void))NURBS_Err);	// NURBS֘ÃG[̃R[obN֐o^

	NurbsSurf = gluNewNurbsRenderer();
	gluNurbsProperty(NurbsSurf,GLU_SAMPLING_TOLERANCE,50);
	gluNurbsCallback(NurbsSurf, GLU_ERROR, (void (CALLBACK *) (void))NURBS_Err);	// NURBS֘ÃG[̃R[obN֐o^
}

// NURBSȖʂ̕``ύX
void Describe_BODY::SetNurbsSProperty(GLenum prop,GLfloat val)
{
	gluNurbsProperty(NurbsSurf,prop,val);
}


// NURBSȖʂ̑ew
void Describe_BODY::SetNurbsSTolerance(GLfloat t)
{
	gluNurbsProperty(NurbsSurf,GLU_SAMPLING_TOLERANCE,t);
}

// NURBSt@NVG[̃R[obNo^
void Describe_BODY::NURBS_Err(GLenum error_code)
{
	fprintf(stderr,"%s\n",gluErrorString(error_code));
	getchar();
	//exit(1);
}

// ~E~ʂ̕`
void Describe_BODY::DrawCircleArc()
{
	// 
}

// ~Ȑ̕`
void Describe_BODY::DrawConicArc()
{
	// 
}

// 2DpgbN~vf̕`
void Describe_BODY::DrawCircleArc_Param(CIRA *CirA)
{
	// 
}

// 2DpgbN~Ȑvf̕`
void Describe_BODY::DrawConicArc_Param(CONA *ConA)
{
	// 
}

// 2DpgbNvf̕`
void Describe_BODY::DrawLine_Param(LINE_ *Line)
{
	// 
}
