#ifndef _NURBS_FUNC_H_
#define _NURBS_FUNC_H_

#include "BODY.h"
#include "Describe_BODY.h"
#include "Quaternion.h"

#define PTNUMMAX			10000			// NURBS̓_̍ő吔
#define RANKMAX				9				// NURBS̊K̍ől
#define INTERSECPTNUMMAX	1000			// _i[z
#define NEAREST_GAP			0.01			// 2__Ƃ݂Ȃ
#define CONVERG_GAP			0.00001			// j[g@̎𔻕ʂ臒l
#define CONVDIVNUM			10				// vZp̃p[^
#define TRM_BORDERDIVNUM	100				// gEɐ_̐
#define FORWARD				1				// ǐՂ̕()
#define INVERSE				-1				// ǐՂ̕(t)
#define OUTTER_TRIM			0				// Og~Ö
#define INNER_TRIM			1				// g~Ö


// NURBS̑W߂NX`
class NURBS_Func : public BODY_Handler
{
public:
	Coord CalcNurbsCCoord(NURBSC *,double);						// w肵mbgtłNURBSȐ̍Wl߂
	void CalcNurbsCCoords(NURBSC *,int,double *,Coord *);		// w肵mbgtQłNURBSȐ̍WlQ߂
	Coord CalcNurbsSCoord(NURBSS *,double,double);				// w肵mbgu,vłNURBSȖʂ̍W_߂
	void CalcNurbsSCoords(NURBSS *,int,Coord *,Coord *);		// w肵mbgu,vQłNURBSȖʂ̍WlQ߂
	int GenNurbsC(NURBSC *,int,int,int,double [],double [],Coord [],double [],int[],int);	// 1NURBSȐ𐶐
	int GenNurbsC(NURBSC *,NURBSC);								// 1NURBSȐ𐶐(NURBSȐ̃Rs[)(I[o[[h)
	int GenNurbsS(NURBSS *,int,int,int,int,double *,double *,double **,Coord **,double,double,double,double);	// 1NURBSȖʂ𐶐
	int GenNurbsS(NURBSS *,NURBSS);								// 1NURBSȖʂ𐶐(NURBSȖʂ̃Rs[)(I[o[[h)
	int GenRotNurbsS(NURBSS *,NURBSC,Coord,double);				// 1NURBSȐ鎲ɂpx]]T[tFX𐶐
	int GenSweepNurbsS(NURBSS *,NURBSC,Coord,double);			// 1NURBSȐ炠鎲ɂ鋗XC[vXC[vT[tFX𐶐
	int GenTrimdNurbsS(TRIMD_NURBSS *,TRIMD_NURBSS);			// gʂ𐶐
	int DelTrimdNurbsS(TRIMD_NURBSS *);							// gʂ폜([)
	void DelNurbsC(NURBSC *);									// NURBSȐ폜
	void DelNurbsS(NURBSS *);									// NURBSȖʂ폜
	double CalcBSbasis(double,double [],int,int,int);			// BXvC֐vZAvZʂԂ
	double CalcDiffBSbasis(double,double [],int,int,int);		// BXvC֐1KW߂
	double CalcDiffBSbasisN(double,double [],int,int,int,int);	// BXvC֐NKW߂
	Coord CalcDiffNurbsC(NURBSC *,double);						// NURBSȐ1KW߂
	Coord CalcDiff2NurbsC(NURBSC *NurbsC,double t);				// NURBSȐ2KW߂
	Coord CalcDiffuNurbsS(NURBSS *,double,double);				// NURBSȖʂu1KW߂
	Coord CalcDiffvNurbsS(NURBSS *,double,double);				// NURBSȖʂv1KW߂
	Coord CalcDiffNurbsS(NURBSS *,int,int,double,double);		// NURBSȖʂ̊eCӊKƂ̔W߂
	Coord CalcNormVecOnNurbsS(NURBSS *,double,double);			// NURBSȖʏ(u,v)ɂ@xNgƂ߂
	int CalcuIntersecPtNurbsLine(NURBSS *,Coord ,Coord ,Coord *,Coord *);	// NURBSȖʂƒ̌_Zo
	int CalcIntersecCurve3(NURBSC *,Coord,Coord,double *,int);	// 3ȉNURBSȐƕʂƂ̌_߂
	int CalcIntersecPtsPlaneV3(NURBSS *,Coord,Coord,int,Coord *,int);	// 3ȉNURBSȖʂƕʂƂ̌_Q㐔vZŋ߂(vp[^)
	int CalcIntersecPtsPlaneU3(NURBSS *,Coord,Coord,int,Coord *,int);	// 3ȉNURBSȖʂƕʂƂ̌_Q㐔vZŋ߂(up[^)
	int CalcIntersecPtsPlaneSearch3(NURBSS *,Coord,Coord,double,int,Coord *,int);	// 3ȉNURBSȖʂƕʂƂ̌_QǐՖ@ŋ߂
	int CalcIntersecPtsNurbsSGeom(NURBSS *,NURBSS *,int,int,Coord *,Coord *,int);		// NURBSȖʓm̌̓_􉽊wIɂ߂
	int CalcIntersecPtsNurbsSSearch(NURBSS *,NURBSS *,int,double,Coord *,Coord *,int);		// NURBSȖʓm̌(_Q)ǐՖ@ŋ߂
	int GetBSplCoef3(int,int,int,double *,double **);			// 3BXvCȐ̊eW߂@(at^3 + bt^2 + ct + ďWa,b,c,dԂ)
	int GetBSplCoef2(int,int,int,double *,double **);			// 2BXvCȐ̊eW߂@(at^2 + bt + čWa,b,cԂ)
	int GetBSplCoef1(int,int,int,double *,double **);			// 1BXvCȐ̊eW߂@(at + b̌Wa,bԂ)
	void ShiftNurbsS(NURBSS *,Coord);							// NURBSȖʂ̃Vtg
	void ShiftNurbsC(NURBSC *,Coord);							// NURBSȐ̃Vtg
	void ChRatioNurbsS(NURBSS *,Coord);							// NURBSȖʂ̔{ύX
	void ChRatioNurbsC(NURBSC *,Coord);							// NURBSȐ̔{ύX
	int SetCPNurbsS(NURBSS *,NURBSS);							// Rg[|Cg
	int GenInterpolatedNurbsC1(NURBSC *,Coord *,int,int);		// ^ꂽ_ԂnKNURBSȐ𐶐
	int GenInterpolatedNurbsC2(NURBSC *,Coord *,int,int);		// ^ꂽ_ԂnKNURBSȐ𐶐(Ȑ)
	int GenApproximationNurbsC(NURBSC *,Coord *,int,int);		// ^ꂽ_ߎnKNURBSȐ𐶐
	int GenPolygonalLine(NURBSC *,Coord *,int);					// ܂𐶐
	int GenInterpolatedNurbsS1(NURBSS *,Coord **,int,int,int,int);	// ^ꂽ_Ԃ4KNURBSȖʂ𐶐
	int GenPolygonalSurface(NURBSS *,Coord **,int,int);				// ܂ʂ𐶐
	int DetermPtOnTRMSurf(TRMS *,double,double);					// ڒNURBSȖʏ1_(u,v)g~Öɂ̂𔻒肷
	void RotNurbsS(NURBSS *,Coord,double);							// NURBSȖʂ]
	void RotNurbsC(NURBSC *,Coord,double);							// NURBSȐ]
	int DetectInterfereNurbsS(NURBSS *,NURBSS *,int);				// NURBSȖ(g)m̊o
	int DetectInterfereTrmS(TRIMD_NURBSS *,TRIMD_NURBSS *,int);		// NURBSȖ(gL)m̊o
	int CalcIntersecPtsPlaneGeom(NURBSS *,Coord,Coord,int,int,Coord *,int);			// NURBSȖʂƕʂƂ̌_Q􉽊wIɋ߂
	double CalcNurbsCLength(NURBSC *);							// NURBSȐ̐߂
	double CalcNurbsCLength(NURBSC *,double,double);			// NURBSȐ̎wԂ̐߂
	int CalcDeltaPtsOnNurbsC(NURBSC *,double,Coord *);			// w肵ԊuNURBSȐ̍Wlo͂
	int CalcExtSearchCurve(NURBSS *,Coord,Coord,double,NURBSC *,NURBSC *);			// ɒnT𓾂
	int CalcExtGradCurve(NURBSS *,Coord,Coord,double,NURBSC *,NURBSC *);			// ɒnXΐ𓾂


private:
	int GetNurbsCCoef(NURBSC *,double **,int,Coord *,double *);	// NURBSȐ̌W߂(ō3)
	int CalcEquation(double *,double *,int);					// 3܂ł𔻕ʂĉ
	void GetNurbsSCoef(int,double **,double *,Coord *,int,Coord *,double *);	// NURBSȖʂɂu܂vŒ肵ꍇɓNURBSȐC(u) or C(v)̕ꕪq̌W߂
	void GetIntersecEquation(int,Coord *,double *,Coord,Coord,double *);		// NURBSȐƕʂ̌op3𓾂
	int SearchIntersectPt(NURBSS *,Coord,Coord,double,double *,double *,int);	// j[g@ɂ_(NURBSȖʂƕ)
	int SearchIntersectPt_RKM(NURBSS *,Coord,Coord,double,double *,double *,int);	// 4̃QNb^@ɂ_(NURBSȖʂƕ)
	int SearchIntersectPt(NURBSS *,NURBSS *,double,double *,double *,double *,double *,int);		// j[g@ɂ_(NURBSȖʓm)
	int DetermPtOnTRMSurf_sub(CONPS *,double,double);						// gEȐ̏ꍇ̃g~ÖO
	void GetKnot(Vector,int,int,int,Vector);						// Ȑp[^mbgxNg𓾂
	void GetKnotParam1(Coord *,int,Vector);							// eʉߓ_̋Ȑp[^Zo(R[h̔䂩Zo)
	void GetKnotParam2(Coord *,int,Vector);							// eʉߓ_̋Ȑp[^Zo(R[h̔̕䂩Zo)
	int CheckTheSamePoints(Coord *,int);							// _
	double CalcDiffNurbsSDenom(NURBSS *,int,int,double,double);		// NURBSȖʕ̊eCӊKƂ̔W߂
	Coord CalcDiffNurbsSNumer(NURBSS *,int,int,double,double);		// NURBSȖʕq̊eCӊKƂ̔W߂

};

#endif
